=== debian/control ===
Source: duckstation
Section: games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Build-Depends: cmake,
  debhelper-compat (= 12),
  extra-cmake-modules,
  libcpuinfo-dev,
  libcubeb-dev,
  libcurl4-openssl-dev,
  libdrm-dev,
  libfmt-dev,
  libgbm-dev,
  glslang-dev,
  libasound2-dev,
  libgtest-dev,
  libicu-dev,
  libimgui-dev (>= 1.88),
  libjpeg-dev,
  libminizip-dev,
  libpng-dev,
  libpulse-dev,
  librcheevos-dev,
  libsdl2-dev,
  libsimpleini-dev,
  libsndio-dev,
  libstb-dev,
  libtinyxml2-dev,
  libvulkan-dev,
  libvulkan-memory-allocator-dev,
  libwebp-dev,
  libxxhash-dev,
  libzstd-dev,
  libzydis-dev,
  qt6-base-private-dev,
  qt6-tools-dev,
  rapidjson-dev,
  spirv-headers
Standards-Version: 4.6.2
Homepage: https://www.duckstation.org/

Package: duckstation
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt6svg6, duckstation-data (= ${source:Version})
Description: Sony PlayStation emulator
 DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
 focusing on playability, speed, and long-term maintainability.

Package: duckstation-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: duckstation
Description: Sony PlayStation emulator (data files)
 DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
 focusing on playability, speed, and long-term maintainability.
 .
 This package contains the platform independent data files for DuckStation.

#Package: libretro-duckstation
#Architecture: any
#Multi-Arch: same
#Depends: retroarch | libretro-frontend, ${misc:Depends}, ${shlibs:Depends}
#Description: Libretro wrapper for DuckStation
# This wrapper makes DuckStation API compatible with libretro, thus allowing
# its use with libretro frontends, such as RetroArch.
# .
# DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
# focusing on playability, speed, and long-term maintainability.
