=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
#	dh_auto_configure --builddir=deblibretro -- -DENABLE_DISCORD_PRESENCE=OFF -DBUILD_LIBRETRO_CORE=ON
	dh_auto_configure --builddir=debqt6 -- -DUSE_WAYLAND=ON -DUSE_X11=ON -DENABLE_DISCORD_PRESENCE=OFF

override_dh_auto_build:
#	dh_auto_build --builddir=deblibretro
	dh_auto_build --builddir=debqt6

override_dh_auto_clean:
#	dh_auto_clean --builddir=deblibretro
	dh_auto_clean --builddir=debqt6
