## duckstation 0.1-7465

=== debian/changelog ===
duckstation (0.1-7465-0+twolife2) unstable; urgency=low

  * Initial release. Maybe last release as the maintainers
    of DuckStation updated their license, changing it to the
    PolyForm Strict License 1.0.0, a non-free software license.

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 06 Nov 2024 08:29:07 +0100
