=== debian/control ===
Source: duckstation
Section: games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Build-Depends: cmake,
  debhelper-compat (= 12),
  extra-cmake-modules,
  libavcodec-dev, libavformat-dev, libavutil-dev, libswresample-dev, libswscale-dev,
  libasound2-dev,
  libbacktrace-dev,
  libcpuinfo-dev,
  libcubeb-dev,
  libcurl4-openssl-dev,
  libdiscord-rpc-dev,
  libdrm-dev,
  libfmt-dev,
  libgbm-dev,
  libgtest-dev,
  libicu-dev,
  libimgui-dev (>= 1.90.9),
  libjpeg-dev,
  libkissfft-dev,
  libminizip-dev,
  libpng-dev,
  libpulse-dev,
#  librcheevos-dev,
  libsdl2-dev,
  libshaderc-dev,
#  libsimpleini-dev,
  libsoundtouch-dev,
  libspirv-cross-c-shared-dev,
  libstb-dev,
  libtinyxml2-dev,
  libvulkan-dev,
  libvulkan-memory-allocator-dev,
  libwebp-dev,
  libxxhash-dev,
  libzstd-dev,
  libzydis-dev,
  qt6-base-private-dev (>= 6.7.2),
  qt6-tools-dev,
  rapidjson-dev,
  spirv-headers
Standards-Version: 4.7.0
Homepage: https://www.duckstation.org/

Package: duckstation
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt6svg6, libshaderc1, duckstation-data (= ${source:Version})
Description: Sony PlayStation emulator
 DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
 focusing on playability, speed, and long-term maintainability.

Package: duckstation-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: duckstation
Description: Sony PlayStation emulator (data files)
 DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
 focusing on playability, speed, and long-term maintainability.
 .
 This package contains the platform independent data files for DuckStation.
